/**
 * 文件名：app.js
 * 描述：
 */
var sliderTmpl = $('#sliderTmpl').text();
var recmondTmpl = $('#recmdTmpl').text();
var listTmpl = $('#listTmpl').text();
var navTmpl = $('#nav-tmpl').text();
var pullNavTmpl = $('#pull-nav-tmpl').text();
var otherListTmpl = $('#other-list-tmpl').text();
var searchTmpl = $('#search-tmpl').text();
var categoryTmpl = $('#categoryTmpl').text();

var initHomeFalg = false;
var pageIndex = 1,
	listRow = 10,
	pullIndex = 0;
var pullServerTmp = pullServer;
String.prototype.temp = function(obj) {
	return this.replace(/\##\w+\##/gi, function(matchs) {
		var returns = obj[matchs.replace(/\##/g, "")];
		return (returns + "") == "undefined" ? "" : returns;
	});
};

var swiper = new Swiper('#banner-slider', {
	pagination: '.swiper-pagination',
	paginationClickable: true,
	autoplay: '2000',
	loop: true
});

var pullDataFlag = true,
	isPulling = false;
var pullDownTip = (function() {
	var tipEle = $('.refresh-tip');
	return {
		show: function() {
			tipEle.show();
		},
		hide: function() {
			setTimeout(function() {
				tipEle.hide();
			}, 1000)
		},
		loadText: function() {
			tipEle.find('span').html('正在加载');
			tipEle.find('img').show();
		},
		pullRefresh: function() {
			pullDataFlag = true;
			tipEle.find('span').html('正在加载');
			tipEle.show();
		},
		endPullupToRefresh: function(flag) {
			if (flag) {
				tipEle.find('span').html('更多精彩，敬请期待！');
				tipEle.find('img').hide();
				pullDataFlag = false;
			} else {
				tipEle.find('span').html('正在加载');
				tipEle.find('img').show();
			}

		}
	}
}());

mui.plusReady(function() {
	
	var initHomePape = function(){
			// init banners
			mui.ajax(apiServer + 'getGameBanners', {
				crossDomain: true,
				success: function(data) {
					if (!data) return true;
					var banner = data
					var sliderArr = []; 
					for (var i = 0; i < banner.length; i++) {
						banner[i]['img_url'] = resAdmin + banner[i]['img_url'];
						var temp = sliderTmpl.temp(banner[i]);
						sliderArr.push(temp);
					}
					swiper.appendSlide(sliderArr);
					initHomeFalg = true;
				},
			})
		
			mui.ajax(apiServer + 'getRecommend', {
				crossDomain: true, 
				success: function(data) {
					if (!data) return true;
					var rcmd = data;
					var html = '';
					for (var i = 0; i < rcmd.length; i++) {
						rcmd[i]['img'] = resAdmin + rcmd[i]['img'];
						rcmd[i]['id'] = playServer + rcmd[i]['id'];
						var temp = recmondTmpl.temp(rcmd[i]);
						html += temp;
					}
					$('#recmd').append(html);
				}
			})
			
			mui.ajax(apiServer + 'getCategory', {  
				crossDomain: true, 
				success: function(data) {
					if (!data) return true;
					var rcmd = data;
					var html = '';
					for (var i = 0; i < 4; i++) {
						rcmd[i]['id'] = rcmd[i]['id'];				
						var temp = categoryTmpl.temp(rcmd[i]);
						html += temp; 
					}
					$('#category-1').append(html);
					html = '';
					for (var i = 4; i < 8; i++) {
						rcmd[i]['id'] = rcmd[i]['id'];				
						var temp = categoryTmpl.temp(rcmd[i]);
						html += temp;
					}
					$('#category-2').append(html);
				} 
			})
			
			muiPullRefesh(pullServerTmp);
	}			

	window.onscroll = function() {
		var top = document.documentElement.scrollTop || document.body.scrollTop;
		if (top + document.body.clientHeight >= document.body.scrollHeight - 40) {
			if (pullDataFlag)
				muiPullRefesh();
		}
	}

	mui("#mul-nav").on('tap', '.pull-tab', function() {
		//获取id
		if ($(this).hasClass('mui-active')) {
			return true;
		}
		$('.pull-tab').removeClass('mui-active');
		$(this).addClass('mui-active');

		pullDownTip.pullRefresh();
		//mui('#list-content').pullRefresh().refresh(true);
		pageIndex = 1;
		pullServerTmp = pullServer + $(this).attr('url') ;
		console.log(pullServerTmp);
		//$('.pull-list-ul').html('');
		muiPullRefesh();
	})

	function muiPullRefesh() {
		var self = this;
		pullDownTip.show();
		if (isPulling) return false;
		isPulling = true;
		var url = pullServerTmp + '/pageIndex/' + pageIndex;
		mui.ajax(url, {
			crossDomain: true,
			success: function(data) {
				var list = data;
				var html = '';
				if (!list) {
					self.endPullupToRefresh(true);
					return true;
				} 
				// 切换列表模板
				var tmpl = listTmpl;

				for (var i = 0; i < list.length; i++) {
					list[i]['img'] = resAdmin + list[i]['img'];
					list[i]['id'] = playServer + list[i]['id'];
					var temp = tmpl.temp(list[i]);
					html += temp;
				}
				if (pageIndex < 2) {
					$('.pull-list-ul').html(html);
				} else {
					$('.pull-li-item').eq(-1).after(html);
				}

				pageIndex++;
				if (list.length < listRow) {
					pullDownTip.endPullupToRefresh(true);
				} else {
					pullDownTip.endPullupToRefresh(false);
				}
				isPulling = false;

			},
			error:function(){
				console.log('ajax error');
				isPulling = false;
			}
		})
	}
	

	document.addEventListener( "netchange", onNetChange, false );  
	function onNetChange() {
		var nt = plus.networkinfo.getCurrentType();
		switch ( nt ) {
			case plus.networkinfo.CONNECTION_ETHERNET:
			case plus.networkinfo.CONNECTION_WIFI:
			console.log("Switch to Wifi networks!"); 
			if(!initHomeFalg){
				initHomePape();
			} 
			break; 
			case plus.networkinfo.CONNECTION_CELL2G:
			case plus.networkinfo.CONNECTION_CELL3G:
			case plus.networkinfo.CONNECTION_CELL4G:
			if(!initHomeFalg){
				initHomePape();
			}
			console.log("Switch to Cellular networks!");  
			break; 
			default:
			console.log("Not networks!"); 
			break;
		}
	}
	initHomePape();
})

document.getElementById('search-btn').onclick = function() {
	var action = apiServer + 'search/q/' + $('#search').val();
    console.log(action);
	$.get(action, function(response) {
		var content = response.content;
		$('.main-content').hide();
		if (response.rcmd) {
			$('#search-tip').text('未找到相关测试，试试这些');
		} else {
			$('#search-tip').html('与<strong>' + $('#search').val() + '</strong>相关测试');
		}
		if (content) {
			var htmlList = '';
			for (var i = 0; i < content.length; i++) {
				content[i]['img'] = resAdmin + content[i]['img'];
				content[i]['id'] = playServer + content[i]['id'];
				htmlList += searchTmpl.temp(content[i]);
			}
			$('#search-wrap').html(htmlList);
			$('.search-rcmd').show();
		}
	})
}
$('.search-rcmd-close').click(function() {
	$('.search-rcmd').hide();
	$('.main-content').show();
})