/**
 * 文件名:function.js
 * 描述:包含整个app中全部共用方法
 * 更新时间:2016-07-18
 */
var _openw = null;
var as = 'pop-in'; // 默认窗口动画
var preate = {};
var webview = [];
var statusBarHeight = 20;
var quitFlag = false;//是否在主界面点击了返回键
var storagePrefix = 'quce_';
function clicked(id, offset, a, s) {
	if(plus.networkinfo.getCurrentType() == 1){
		plus.nativeUI.toast('请检查网络连接');
		return true;
	}
	if (_openw) {
		return;
	}
	a || (a = as);
	offset = offset?44:0;
	console.log(offset);
	//_openw=preate[id];
	if (_openw) {
		_openw.showded = true;
		_openw.show(a, null, function() {
			_openw = null; //避免快速点击打开多个页面
		});
	} else {
		var wa = plus.nativeUI.showWaiting();
		webview.push(id);

		if (navigator.userAgent.indexOf('iPhone') > -1) {
			_openw = plus.webview.create(id, id, {
				scrollIndicator: 'none',
				scalable: false,
				popGesture: 'none',
				top: statusBarHeight + offset + "px"
			}, {
				preate: true
			});

		} else {
			_openw = plus.webview.create(id, id, {
				scrollIndicator: 'none',
				scalable: false,
				popGesture: 'none',
				top: offset + "px"
			}, {
				preate: true
			});

		}

		preate[id] = _openw;
		
		wa.onclose = function() {
			plus.webview.close(id);
			wa.close();
		};
		
		_openw.addEventListener('loaded', function() {
			//叶面加载完成后才显示
			setTimeout(function() { //延后显示可避免低端机上动画时白屏
				wa.onclose = null;
				wa.close();
				_openw.showded = true;
				s || _openw.show(a, null, function() {
					_openw = null; //避免快速点击打开多个页面
				});
				s && (_openw = null); //避免s模式下变量无法重置

			}, 10);
		}, false);
		_openw.addEventListener('close', function() { //页面关闭后可再次打开
			console.log('close')
			plus.navigator.setStatusBarStyle('UIStatusBarStyleDefault');
			_openw = null;
			preate[id] && (preate[id] = null); //兼容窗口的关闭
		}, false);
		
		//检测是否是外链，重写返回方法
		if (id.indexOf(apiHost) == -1) {
			console.log('这是外链' + id);
			var thisWebView = plus.webview.getWebviewById(plus.webview.getTopWebview().id)
			var old_back = mui.back;
			thisWebView.addEventListener('loaded', function() {
				mui.back = function() {
					plus.webview.close(id);
				}
			})
	
			thisWebView.addEventListener('close', function() { //页面关闭后可再次打开
				mui.back = old_back;
			})
		}
	}

}

function plusReady() {
	console.log("UA:" + navigator.userAgent)
	if (navigator.userAgent.indexOf('iPhone') > -1) {
		statusBarHeight = plus.navigator.getStatusbarHeight();
	}

}
if (window.plus) {
	plusReady();
} else {
	document.addEventListener('plusready', plusReady, false);
}
String.prototype.temp = function(obj) {
	return this.replace(/\##\w+\##/gi, function(matchs) {
		var returns = obj[matchs.replace(/\##/g, "")];
		return (returns + "") == "undefined" ? "" : returns;
	});
};


function quitApp() {
    console.log('back click');
	if (quitFlag) {
		//quit
		var main = plus.android.runtimeMainActivity();
    	main.moveTaskToBack(false);
	} else {
		quitFlag = true;
		setTimeout(function() {
			quitFlag = false;
		}, 3000);
		mui.toast('再按一次退出「趣测」');
	}
}

function selfCloseSplash(delay){
	setTimeout(function(){
		plus.navigator.closeSplashscreen();
	},delay*1000)
}

function getQueryString(name) { 
	var reg = new RegExp("(^|&)" + name + "=([^&]*)(&|$)", "i"); 
	var r = window.location.search.substr(1).match(reg); 
	if (r != null) return unescape(r[2]); return null; 
}

function getLocalUid(){
	
	var uid = localStorage.getItem(storagePrefix+"uid");
	if(parseInt(uid) > 0){
		return uid;
	}	
	return false;
	
}

function setLocalUid(uid){
	localStorage.getItem(storagePrefix+"uid", uid);
}
